#include <stdio.h>
#include <stdarg.h>
#include <errno.h>

extern char *argv0;

int
err(int ecode,
    char *fmt,
    ...)
{
    va_list ap;
    int serrno = errno;
    
    
    va_start(ap, fmt);
    if (argv0)
	fprintf(stderr, "%s: ", argv0);
    
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, ": %s\n", strerror(serrno));
    
    exit(ecode);
}


int
errx(int ecode,
    char *fmt,
    ...)
{
    va_list ap;
    
    
    va_start(ap, fmt);
    if (argv0)
	fprintf(stderr, "%s: ", argv0);
    
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
    
    exit(ecode);
}

int
warn(int ecode,
    char *fmt,
    ...)
{
    va_list ap;
    int serrno = errno;
    
    
    va_start(ap, fmt);
    if (argv0)
	fprintf(stderr, "%s: ", argv0);
    
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, ": %s\n", strerror(serrno));
}
